'use strict';

module.exports = function createElement(tagName, props) {
  for (var _len = arguments.length, children = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
    children[_key - 2] = arguments[_key];
  }

  if (typeof tagName === 'function') {
    var Component = tagName;
    if (Component.prototype) {
      var component = new Component(Object.assign({}, props, { children: children }));
      return component.render ? component.render() : component;
    } else {
      return Component(props);
    }
  }
  return Object.assign({ tagName: tagName }, props, { children: children });
};