'use strict';

var state = [];
var cursor = -1;

function useState(initialState) {
  var current = cursor++;
  var setter = function setter(value) {
    state[current] = typeof value === 'function' ? value() : value;
    if (useState.dispatch) Promise.resolve(state[current]).then(function () {
      return useState.flush() && useState.dispatch();
    });
  };
  return [state[current] || initialState, setter];
}

// internal, only used for tests
useState.__reset = function () {
  state = [];
  cursor = [];
  useState.flush();
};

useState.flush = function () {
  return cursor = -1;
};

module.exports = useState;